library DllTest;

uses
  SysUtils,
  Classes;

{$R *.res}

type
  TpdScriptCallback = function(ScriptInstance:Pointer; FunctionName:PAnsiChar; Params:PAnsiChar):Boolean; stdcall;

function MyDllFunction(Params:PAnsiChar):PAnsiChar; stdcall;
var
  i:Integer;
  SL:TStringList;
  tmp,res:AnsiString;
  sfnc,sprms:PAnsiChar;
  CH:Int64;             // A pointer to the Callback function (in an integer form)
  C:TpdScriptCallback;  // Callback function
  SI:Pointer;           // An instance of script interpreter that will be used to execute the callback function
begin
  res:='Params passed to the Dll:';
  tmp:='';
  try
    SL:=TStringList.Create;
    SI:=nil;
    CH:=0;
    C:=nil;
    sfnc:=nil;
    sprms:=nil;
    try
      SL.Text:=Params;
      // parse callback parameters
      i:=SL.IndexOfName('CallbackInstance');
      if i>=0 then
      begin
        SI:=Pointer(StrToInt64Def(SL.ValueFromIndex[i],0));
        SL.Delete(i);
      end;
      i:=SL.IndexOfName('CallbackHandler');
      if i>=0 then
      begin
        CH:=StrToInt64Def(SL.ValueFromIndex[i],0);
        SL.Delete(i);
      end;
      i:=SL.IndexOfName('CallbackScriptFnc');
      if i>=0 then
      begin
        tmp:=SL.ValueFromIndex[i];
        SL.Delete(i);
      end;

      if (SI<>nil) and (CH>0) and (Length(tmp)>0) then
      begin
        C:=TpdScriptCallback(CH);
        getmem(sfnc,Length(tmp)+1);
        StrPCopy(sfnc,tmp);
      end;

      // process Dll function
      for i:=0 To SL.Count-1 do
      begin
        tmp:=SL[i];
        if Assigned(C) then
        begin
          getmem(sprms,Length(tmp)+1);
          StrPCopy(sprms,tmp);
          if C(SI,sfnc,sprms) then
            res:=res+#13#10+sprms;
          freemem(sprms);
        end
        else
          res:=res+#13#10+tmp;
      end;
    finally
      SL.Free;
      if Assigned(sfnc) then
        FreeMem(sfnc);
    end;
  except
    on E:Exception do
      tmp:=e.Message;
  end;
  getmem(Result,Length(res)+1);
  StrPCopy(Result,res);
end;

exports
  MyDllFunction;

begin
	IsMultiThread := True;
end.
